package com.blackledge.david.tivo.game;

import java.awt.Color;

import com.blackledge.david.game.Card;
import com.tivo.hme.bananas.BView;
import com.tivo.hme.sdk.Resource;

public class CardView extends BView {

	private BView _numberTL;
	private BView _numberBR;
	private BView _face;
	private Card _currentState;

	public CardView(BView parent, int x, int y, int width,
			boolean visible, Card card) {
		super(parent, x, y, width, getHeight(width), visible);
		_numberTL = new BView(this, 0, 0, getWidth(), getHeight(), false);
		_numberBR = new BView(this, 0, 0, getWidth(), getHeight(), false);
		_face = new BView(this, 0, 0, getWidth(), getHeight(), false);
		setState(card);
	}

	public void setState(Card card) {
		if(card == null) return;
		
		setPainting(false);
		
		boolean flipped = false;
		if (_currentState == null || card.isFaceUp() != _currentState.isFaceUp()) {
			flipped = true;
			_numberTL.setVisible(card.isFaceUp());
			_numberBR.setVisible(card.isFaceUp());
			_face.setVisible(card.isFaceUp());
			if(card.isFaceUp()) {
				setResource(getCardFaceResource(card.getSuit()));
			} else {
				setResource(getCardBackResource());
			}
		} else {
			if (card.isFaceUp()) {
				if (_currentState == null || card.getSuit() != _currentState.getSuit()) {
					setResource(getCardFaceResource(card.getSuit()));
				}
			}
		}
		if (card.isFaceUp()) {
			if (flipped || _currentState == null
					|| card.getValue() != _currentState.getValue()
					|| card.getSuitColor() != _currentState.getSuitColor()) {
				Color suitColor = Color.black;
				if(card.getSuitColor() == Card.RED) {
					suitColor = Color.red;
				}
				Resource number = createText("default-15-bold.font", suitColor, card.getValueString());
				_numberTL.setResource(number, RSRC_VALIGN_TOP|RSRC_HALIGN_LEFT);
				_numberBR.setResource(number, RSRC_VALIGN_BOTTOM|RSRC_HALIGN_RIGHT);
				
				Resource faceResource = null;
//				switch(card.getValue()) {
//				case Card.ACE:
//					switch(card.getSuit()) {
//					case Card.CLUB:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.DIAMOND:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.HEART:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					case card.SPADE:
//						faceResource = getResource("http://enterwebz.tv/");
//						break;
//					}
//					break;
//				case Card.JACK:
//					faceResource = getResource("http://enterwebz.tv/");
//					break;
//				case Card.QUEEN:
//					faceResource = getResource("http://enterwebz.tv/");
//					break;
//				case Card.KING:
//					faceResource = getResource("http://enterwebz.tv/");
//					break;
//				default:
//					faceResource = createText("default-40.font", suitColor, card.getValueString());
//					break;
//				}
				
faceResource = createText("default-"+(getWidth()*2/3)+".font", suitColor, card.toString());

				_face.setResource(faceResource, RSRC_HALIGN_CENTER|RSRC_VALIGN_CENTER);
			}
		}
		
		setPainting(true);

		_currentState = new Card(card.getSuit(), card.getValue(), card.isFaceUp());
	}
	
	private Object getCardBackResource() {
		return Color.ORANGE.darker().darker();
	}

	private Object getCardFaceResource(int suit) {
		return Color.WHITE.darker();
	}

	public static int getHeight(int width) {
		return (int) (width*(3.5/2.5));
	}

}
